Subject: Re: [Bitcoin-development] BIP - Selector Script

From: "Luke-Jr" <[email-masked]>
Date: Fri, 25 Apr 2014 19:17:48 +0000

I believe you meant to link here instead?
    https://github.com/TierNolan/bips/blob/bip4x/bip-0046.mediawiki

This looks reasonable from a brief skim over, but does not define any use 
cases (it mentions "necessary for atomic cross chain transfers", but does not 
explain how it is useful for that - perhaps that belongs in another BIP you 
haven't written yet, though). IMO, it should also require P2SH.

Luke

On Friday, April 25, 2014 6:49:35 PM Tier Nolan wrote:
> This is a BIP to allow the spender to choose one of multiple standard
> scripts to use for spending the output.
> 
> https://github.com/TierNolan/bips/blob/bip4x/bip-0045.mediawiki
> 
> This is required as part of the atomic cross chain transfer protocol.  It
> is required so that outputs can be retrieved, if the process ends before
> being committed.
> 
> https://bitcointalk.org/index.php?topic=193281.msg2224949#msg2224949
> 
> The script allows multiple standard scripts to be included in the
> scriptPubKey.
> 
> When redeeming the script the spender indicates which of the standard
> scripts to use.
> 
> Only one standard script is actually executed, so the only cost is the
> extra storage required.
> 
> A more ambitious change would be a soft fork like P2SH, except the spender
> is allowed to select from multiple hashes.  Effectively, it would be
> "Multi-P2SH".
> 
> This gets much of the benefits of MAST, but it requires a formal soft fork
> to implement.
> 
> If there is agreement, I can code up the reference implementation as a PR.
> The multi-P2SH might actually be easier.